<img src="docs/logos/arborx_logo_v1.0.png" width="192">

ArborX
======
ArborX is an open-source library designed to provide performance portable
algorithms for geometric search, similarly to nanoflann and Boost Geometry.

Installation
------------
The installation instructions can be found [here](https://github.com/arborx/ArborX/wiki/Build).

Using ArborX
------------
The interface is described [here](https://github.com/arborx/ArborX/wiki/ArborX%3A%3ABoundingVolumeHierarchy).

Examples
--------
Examples can be found in the [examples directory](https://github.com/arborx/ArborX/examples).

Questions, Bug Reporting, and Issue Tracking
--------------------------------------------
Questions, bug reporting and issue tracking are provided by GitHub. Please
report all bugs by creating a new issue with the "bug" tag. You can ask
questions by creating a new issue with the "question" tag.

Contributing
------------
We encourage you to contribute to ArborX! Please check out the
[guidelines](CONTRIBUTING.md) about how to proceed.

Citing ArborX
-------------
If you publish work which mentions ArborX, please cite the following paper:

```BibTeX
@article{arborx2020,
  author = {Lebrun-Grandi\'{e}, D. and Prokopenko, A. and Turcksin, B. and Slattery, S. R.},
  title = {{ArborX}: A Performance Portable Geometric Search Library},
  year = {2020},
  issue_date = {December 2020},
  publisher = {Association for Computing Machinery},
  address = {New York, NY, USA},
  volume = {47},
  number = {1},
  issn = {0098-3500},
  url = {https://doi.org/10.1145/3412558},
  doi = {10.1145/3412558},
  journal = {ACM Trans. Math. Softw.},
  month = dec,
  articleno = {2},
  numpages = {15}
}
```

License
-------
ArborX has a [BSD 3-clause open-source license](LICENSE).
